Subject: Re: [Lake] 1 week 2nd WGLC on requirements and scoping text

From: Göran Selander <[email-masked]>
Date: Tue, 2 Jun 2020 13:48:57 +0000

From: Eric Rescorla <[email-masked]>

The scoping text added was:

   As illustrated above, the setting is much more diverse
   in terms of credentials and trust anchors than that of
   the unconstrained web.  In order to deliver a timely
   result, there is a need to initially focus on what is
   considered most important at the time of writing: RPK
   (by reference and value) and certificate by reference.
   Information about validity of a certificate may be
   omitted from the AKE if available over unconstrained
   links.  The case of transporting certificate validation
   information over the AKE may be specified in the initial
   phase if there is a lightweight solution that matches
   existing standards and tools.

   A subsequent extension beyond the initial focus may be
   inevitable to maintain a homogenous deployment without
   having to implement a mix of AKE protocols, for example,
   to support the migration path described above.  The AKE
   needs to make clear the scope of cases analysed in the
   initial phase, and that a new analysis is required for
   additional cases.

Stephen

It's not clear how to read this in the context of other parts of
the document, for instance: https://tools.ietf.org/html/draft-ietf-lake-reqs-03#section-2.2
which says:

   In order to allow for these different schemes, the AKE must support

   PSK- (shared between two nodes), RPK- and certificate-based

   authentication.  These are also the schemes for which CoAP is

   designed (see Section 9 of [RFC7252]<https://tools.ietf.org/html/rfc7252#section-9>).

How is one supposed to interpret this text?

[GS] Since OSCORE is an extension to CoAP it is expected to support the schemes for which CoAP is designed. But in the discussion following the virtual IETF 107 LAKE WG meeting we restricted the initial focus, leading to the addition of section 2.2.1 and the following text in the paragraph after the one you quoted:

”In order to provide a clear initial effort, Section 2.2.1<https://www.ietf.org/id/draft-ietf-lake-reqs-03.html#initial-focus> lists a set of credential types of immediate relevance; the mechanism for selecting credential scheme is presumed to enable future extensibility if needed.”

The ability to extend beyond the initial focus is also repeated in the text from Section 2.2.1 which Stephen quoted in his mail:

”A subsequent extension beyond the initial focus may be inevitable to maintain a homogenous deployment without having to implement a mix of AKE protocols, for example, to support the migration path described above.”

Yes, my point is that these three paragraphs together contradict each other. One says the AKE MUST support PSK and the other says it's not part of the initial focus. Does that mean that the AKE as published will or will not support PSK?

[GS] The AKE which we will start work on will not include the PSK ECHDE variant. The process for how to include that variant is as far as I know not defined, but it must be possible to extend to that variant at a later stage given that the appropriate analysis etc. is made.

Göran

---

From: Eric Rescorla <[email-masked]>
Date: Tue, 2 Jun 2020 09:36:58 -0700

On Tue, Jun 2, 2020 at 6:48 AM Göran Selander <[email-masked]>
wrote:

>
>
> *From: *Eric Rescorla <[email-masked]>
>
>
> the document, for instance:
> https://tools.ietf.org/html/draft-ietf-lake-reqs-03#section-2.2
>
> which says:
>
>
>
>    designed (see Section 9 of [RFC7252] <https://tools.ietf.org/html/rfc7252#section-9>).
>
> ”In order to provide a clear initial effort, Section 2.2.1
> <https://www.ietf.org/id/draft-ietf-lake-reqs-03.html#initial-focus>
> lists a set of credential types of immediate relevance; the mechanism for
> selecting credential scheme is presumed to enable future extensibility if
> needed.”
>
>
>
> The ability to extend beyond the initial focus is also repeated in the
> text from Section 2.2.1 which Stephen quoted in his mail:
>
>
>
> ”A subsequent extension beyond the initial focus may be inevitable to
> maintain a homogenous deployment without having to implement a mix of AKE
> protocols, for example, to support the migration path described above.”
>
>
>
> Yes, my point is that these three paragraphs together contradict each
> other. One says the AKE MUST support PSK and the other says it's not part
> of the initial focus. Does that mean that the AKE as published will or will
> not support PSK?
>
>
>
>
>
> [GS] The AKE which we will start work on will not include the PSK ECHDE
> variant.
>

I don't think this answers my question, which is not about where we start
work, but what is an acceptable output of this WG.

To restate it more crisply: would an AKE which was extensible but did not
include PSK be conformant with the requirements? It seems to me that the
document is unclear on this point.

-Ekr

The process for how to include that variant is as far as I know not
> defined, but it must be possible to extend to that variant at a later stage
> given that the appropriate analysis etc. is made.
>
>
>
>
>
> Göran
>
>
>
>
>
>
>
>
>
>
>

---

From: Göran Selander <[email-masked]>
Date: Tue, 2 Jun 2020 17:33:05 +0000

From: Eric Rescorla <[email-masked]>
Date: Tuesday, 2 June 2020 at 18:37
To: Göran Selander <[email-masked]>
Cc: Stephen Farrell <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: Re: [Lake] 1 week 2nd WGLC on requirements and scoping text

On Tue, Jun 2, 2020 at 6:48 AM Göran Selander <[email-masked]<mailto:[email-masked]>> wrote:

From: Eric Rescorla <[email-masked]<mailto:[email-masked]>>

Stephen

[GS] The AKE which we will start work on will not include the PSK ECHDE variant.

I don't think this answers my question, which is not about where we start work, but what is an acceptable output of this WG.

To restate it more crisply: would an AKE which was extensible but did not include PSK be conformant with the requirements? It seems to me that the document is unclear on this point.

An AKE which is extensible but does not include PSK ECDHE would be conformant with the requirements for the initial scope. As far as I understood, the solution to the initial scope is intended to be a milestone of this WG.

Göran

---

From: Stephen Farrell <[email-masked]>
Date: Sat, 6 Jun 2020 01:35:31 +0100

Hi all,

Thanks all for questions and the expressions of support and
for the work that got us here.

On 02/06/2020 18:33, Göran Selander wrote:
> An AKE which is extensible but does not include PSK ECDHE would be
> conformant with the requirements for the initial scope. As far as I
> understood, the solution to the initial scope is intended to be a
> milestone of this WG.
I think it'd be good to embed the above in the document so
we're clear. Göran - could you do that one way or another?
(Just in case we forget or want to argue about it later:-)

Other than that - I do see rough consensus that we have the
requirements text sufficiently correct to proceed. It is
clearly not a complete consensus, but I think we all knew
that would be the outcome going in, and the objections I
think have been considered here and/or mitigated via the
adoption of cTLS in the TLS WG.

That being so, I'll chat with my now no longer conflicted
co-chair about next steps, but as I said before I expect
the next step is we'll ask if the WG want to adopt edhoc.
Expect that to kick off next Monday.

If anyone has any alternative next step (e.g. another I-D
to suggest we consider) then now is a really good time to
say that and later would be an awfully less good time.

Thanks,
S.